Index: /trunk/gsdl/macros/spanish2.dm
===================================================================
--- /trunk/gsdl/macros/spanish2.dm	(revision 3298)
+++ /trunk/gsdl/macros/spanish2.dm	(revision 3299)
@@ -7,8 +7,10 @@
 
 
+
 ######################################################################
 # 'home' page
 package home
 ######################################################################
+
 
 #------------------------------------------------------------
@@ -37,5 +39,5 @@
 
 _textimagegogreenstone_ [l=es] { 
-Le cuenta del software Greenstone et del proyecto de biblioteca digital
+Le cuenta del software Greenstone y del proyecto de biblioteca digital
 de Nueva Zelandia, de donde viene
 }
@@ -81,5 +83,5 @@
 un nuevo procedimiento para organizar la informaciÃ³n y publicarla en
 Internet o en forma de CD-ROM. Elaborado dentro del proyecto de
-<b>Biblioteca ElectrÃ³nica de Nueva Zelandia</a> de la <b>Universidad de
+<b>Biblioteca ElectrÃ³nica de Nueva Zelandia</b> de la <b>Universidad de
 Waikato</b>, este producto se distribuye en colaboraciÃ³n con la
 <b>UNESCO</b> y la <b>ONG Human Info</b>.  Es un programa informÃ¡tico de
@@ -161,5 +163,5 @@
 
 ## "seleccionar una colecci&oacute;n" ## green_bar_left_aligned ## selcolgr ##
-_httpiconselcolgr_ [l=es] { _httpimg_/selcolgr.gif}
+_httpiconselcolgr_ [l=es] {_httpimg_/es/selcolgr.gif}
 _widthselcolgr_ [l=es] { 537}
 _heightselcolgr_ [l=es] {17}
@@ -341,5 +343,5 @@
 
 ## "documentaci&oacute;n de greenstone" ## green_bar_left_aligned ## gsdocsgr ##
-_httpicongsdocsgr_ [l=es] {_httpimg_/gsdocsgr.gif}
+_httpicongsdocsgr_ [l=es] {_httpimg_/es/gsdocsgr.gif}
 _widthgsdocsgr_ [l=es] {_pagewidth_}
 _heightgsdocsgr_ [l=es] {17}
@@ -356,14 +358,14 @@
 #------------------------------------------------------------
 
-_textdefaultstructure_ [l=es] { estructura por defecto }
-_textmore_ [l=es] { mÃ¡s }
-_textcollector_ [l=es] { El Collector}
-_textinfo_ [l=es] { Informaciones de colecciÃ³n }
-_textsrce_ [l=es] { Datos fuente } 
-_textconf_ [l=es] { Configurar la colecciÃ³n }
-_textbild_ [l=es] { Construir }
-_textview_ [l=es] { Ver }
-_textdel_ [l=es] { Borrar la colecciÃ³n }
-_textexpt_ [l=es] { Exportar la colecciÃ³n } 
+_textdefaultstructure_ [l=es] {estructura por defecto}
+_textmore_ [l=es] {mÃ¡s}
+_textcollector_ [l=es] {El Collector}
+_textinfo_ [l=es] {Informaciones de colecciÃ³n}
+_textsrce_ [l=es] {Datos fuente} 
+_textconf_ [l=es] {Configurar la colecciÃ³n}
+_textbild_ [l=es] {Construir}
+_textview_ [l=es] {Ver}
+_textdel_ [l=es] {Borrar la colecciÃ³n}
+_textexpt_ [l=es] {Exportar la colecciÃ³n} 
 
 _textcollectorblurb_ [l=es] {
@@ -543,28 +545,11 @@
 }
 
-_textcnmbs_ [l=es] {
-
-Se debe especificar el nombre de la colecciÃ³n
-
-}
-
-_texteambs_ [l=es] {
-
-Se debe especificar la direcciÃ³n de correo electrÃ³nico 
-
-}
-
-_textpsea_ [l=es] {
-
-Especifique por favor la direcciÃ³n de correo electrÃ³nico en el formate:
-usuario@dominio
-
-}
-
-_textdocmbs_ [l=es] {
-
-Se debe especificar la descripciÃ³n de la colecciÃ³n
-
-}
+_textcnmbs_ [l=es] {Se debe especificar el nombre de la colecciÃ³n}
+
+_texteambs_ [l=es] {Se debe especificar la direcciÃ³n de correo electrÃ³nico}
+
+_textpsea_ [l=es] {Especifique por favor la direcciÃ³n de correo electrÃ³nico en el formate: usuario@dominio}
+
+_textdocmbs_ [l=es] {Se debe especificar la descripciÃ³n de la colecciÃ³n}
 
 _textwcanc_ [l=es] {
@@ -799,23 +784,11 @@
 }
 
-_textbsupdate1_ [l=es] { 
-
-ActualizaciÃ³n del estado de la construcciÃ³n en 1 segundo
-
-}
-
-_textbsupdate2_ [l=es] { 
-
-ActualizaciÃ³n del estado de la construcciÃ³n en 
-
-}
+_textbsupdate1_ [l=es] {ActualizaciÃ³n del estado de la construcciÃ³n en 1 segundo}
+
+_textbsupdate2_ [l=es] {ActualizaciÃ³n del estado de la construcciÃ³n en}
 
 _textseconds_ [l=es] {segundos}
 
-_textbildsuc_ [l=es] { 
-
-ColecciÃ³n construida con Ã©xito.
-
-}
+_textbildsuc_ [l=es] {ColecciÃ³n construida con Ã©xito.}
 
 _textviewbildsummary_ [l=es] { 
@@ -1031,48 +1004,48 @@
 
 ## "El collector" ## green_title ## h_colect ##
-_httpiconhcolect_ [l=es] {_httpimg_/h\_colect.gif}
+_httpiconhcolect_ [l=es] {_httpimg_/es/h\_colect.gif}
 
 ## "informaciones de colecci&oacute;n" ## collector_bar_button ## info ##
-_httpicongcinfoof_ [l=es] {_httpimg_/gcinfoof.gif}
-_httpicongcinfoon_ [l=es] {_httpimg_/gcinfoon.gif}
-_httpiconycinfoof_ [l=es] {_httpimg_/ycinfoof.gif}
-_httpiconycinfoon_ [l=es] {_httpimg_/ycinfoon.gif}
-_httpiconncinfoof_ [l=es] {_httpimg_/ncinfoof.gif}
+_httpicongcinfoof_ [l=es] {_httpimg_/es/gcinfoof.gif}
+_httpicongcinfoon_ [l=es] {_httpimg_/es/gcinfoon.gif}
+_httpiconycinfoof_ [l=es] {_httpimg_/es/ycinfoof.gif}
+_httpiconycinfoon_ [l=es] {_httpimg_/es/ycinfoon.gif}
+_httpiconncinfoof_ [l=es] {_httpimg_/es/ncinfoof.gif}
 
 ## "datos fuente" ## collector_bar_button ## srce ##
-_httpicongcsrceof_ [l=es] {_httpimg_/gcsrceof.gif}
-_httpicongcsrceon_ [l=es] {_httpimg_/gcsrceon.gif}
-_httpiconycsrceof_ [l=es] {_httpimg_/ycsrceof.gif}
-_httpiconycsrceon_ [l=es] {_httpimg_/ycsrceon.gif}
-_httpiconncsrceof_ [l=es] {_httpimg_/ncsrceof.gif}
+_httpicongcsrceof_ [l=es] {_httpimg_/es/gcsrceof.gif}
+_httpicongcsrceon_ [l=es] {_httpimg_/es/gcsrceon.gif}
+_httpiconycsrceof_ [l=es] {_httpimg_/es/ycsrceof.gif}
+_httpiconycsrceon_ [l=es] {_httpimg_/es/ycsrceon.gif}
+_httpiconncsrceof_ [l=es] {_httpimg_/es/ncsrceof.gif}
 
 ## "configurar la colecci&oacute;n" ## collector_bar_button ## conf ##
-_httpicongcconfof_ [l=es] {_httpimg_/gcconfof.gif}
-_httpicongcconfon_ [l=es] {_httpimg_/gcconfon.gif}
-_httpiconycconfof_ [l=es] {_httpimg_/ycconfof.gif}
-_httpiconycconfon_ [l=es] {_httpimg_/ycconfon.gif}
-_httpiconncconfof_ [l=es] {_httpimg_/ncconfof.gif}
+_httpicongcconfof_ [l=es] {_httpimg_/es/gcconfof.gif}
+_httpicongcconfon_ [l=es] {_httpimg_/es/gcconfon.gif}
+_httpiconycconfof_ [l=es] {_httpimg_/es/ycconfof.gif}
+_httpiconycconfon_ [l=es] {_httpimg_/es/ycconfon.gif}
+_httpiconncconfof_ [l=es] {_httpimg_/es/ncconfof.gif}
 
 ## "construir la colecci&oacute;n" ## collector_bar_button ## bild ##
-_httpicongcbildof_ [l=es] {_httpimg_/gcbildof.gif}
-_httpicongcbildon_ [l=es] {_httpimg_/gcbildon.gif}
-_httpiconycbildof_ [l=es] {_httpimg_/ycbildof.gif}
-_httpiconycbildon_ [l=es] {_httpimg_/ycbildon.gif}
-_httpiconncbildof_ [l=es] {_httpimg_/ncbildof.gif}
+_httpicongcbildof_ [l=es] {_httpimg_/es/gcbildof.gif}
+_httpicongcbildon_ [l=es] {_httpimg_/es/gcbildon.gif}
+_httpiconycbildof_ [l=es] {_httpimg_/es/ycbildof.gif}
+_httpiconycbildon_ [l=es] {_httpimg_/es/ycbildon.gif}
+_httpiconncbildof_ [l=es] {_httpimg_/es/ncbildof.gif}
 
 ## "visualisar la colecci&oacute;n" ## collector_bar_button ## view ##
-_httpicongcviewof_ [l=es] {_httpimg_/gcviewof.gif}
-_httpicongcviewon_ [l=es] {_httpimg_/gcviewon.gif}
-_httpiconycviewof_ [l=es] {_httpimg_/ycviewof.gif}
-_httpiconycviewon_ [l=es] {_httpimg_/ycviewon.gif}
-_httpiconncviewof_ [l=es] {_httpimg_/ncviewof.gif}
+_httpicongcviewof_ [l=es] {_httpimg_/es/gcviewof.gif}
+_httpicongcviewon_ [l=es] {_httpimg_/es/gcviewon.gif}
+_httpiconycviewof_ [l=es] {_httpimg_/es/ycviewof.gif}
+_httpiconycviewon_ [l=es] {_httpimg_/es/ycviewon.gif}
+_httpiconncviewof_ [l=es] {_httpimg_/es/ncviewof.gif}
 
 ## "borrar la colecci&oacute;n" ## collector_bar_button ## del ##
-_httpicongcdelof_ [l=es] {_httpimg_/gcdelof.gif}
-_httpicongcdelon_ [l=es] {_httpimg_/gcdelon.gif}
+_httpicongcdelof_ [l=es] {_httpimg_/es/gcdelof.gif}
+_httpicongcdelon_ [l=es] {_httpimg_/es/gcdelon.gif}
 
 ## "exportar la colecci&oacute;n" ## collector_bar_button ## expt ##
-_httpicongcexptof_ [l=es] {_httpimg_/gcexptof.gif}
-_httpicongcexpton_ [l=es] {_httpimg_/gcexpton.gif}
+_httpicongcexptof_ [l=es] {_httpimg_/es/gcexptof.gif}
+_httpicongcexpton_ [l=es] {_httpimg_/es/gcexpton.gif}
 
 ######################################################################
@@ -1092,5 +1065,5 @@
 nuevas colecciones. Ofrece une nueva manera de organizar la informaciÃ³n
 y publicarla en la Internet o en un CD-ROM.  Elaborado dentro del
-proyecto de <b>Biblioteca ElectrÃ³nica de Nueva Zelandia</a> de la
+proyecto de <b>Biblioteca ElectrÃ³nica de Nueva Zelandia</b> de la
 <b>Universidad de Waikato</b>, este producto se distribuye en
 colaboraciÃ³n con la <b>UNESCO</b> y la <b>ONG Human Info</b>.  Es un
@@ -1210,5 +1183,5 @@
 
 ## "sobre el software greenstone" ## green_bar_left_aligned ## abgsgr ##
-_httpiconabgsgr_ [l=es] {_httpimg_/abgsgr.gif}
+_httpiconabgsgr_ [l=es] {_httpimg_/es/abgsgr.gif}
 _widthabgsgr_ [l=es] {_pagewidth_}
 _heightabgsgr_ [l=es] {17}