Index: trunk/gsdl3/sites/localsite/collect/chinesedemo/index/buildConfig.xml
===================================================================
--- trunk/gsdl3/sites/localsite/collect/chinesedemo/index/buildConfig.xml	(revision 3480)
+++ trunk/gsdl3/sites/localsite/collect/chinesedemo/index/buildConfig.xml	(revision 3480)
@@ -0,0 +1,26 @@
+<buildConfig>
+<metadataList>
+<metadata name="numDocs">2</metadata>
+<metadata name="colName">chinese demo</metadata>
+<metadata name="defaultIndex">tx</metadata>
+</metadataList>
+<servicesImplList>
+<servicesImpl name="MGPPGDBMServices">
+<defaultIndex name="tx"/>
+<defaultLevel name="Document"/>
+<levelList>
+<level name="Document"/>
+</levelList>
+<indexList>
+<index name="tx"/>
+</indexList>
+</servicesImpl>
+<servicesImpl name="PhindServices" type="query"/>
+<servicesImpl name="GSDL2ClassifierServices" type="query">
+<classifierList>
+<classifier name="CL2" title="Title"/>
+<classifier name="CL3" title="Source"/>
+</classifierList>
+</servicesImpl>
+</servicesImplList>
+</buildConfig>
Index: trunk/gsdl3/sites/localsite/collect/demo/index/buildConfig.xml
===================================================================
--- trunk/gsdl3/sites/localsite/collect/demo/index/buildConfig.xml	(revision 3480)
+++ trunk/gsdl3/sites/localsite/collect/demo/index/buildConfig.xml	(revision 3480)
@@ -0,0 +1,13 @@
+<buildConfig>
+    <metadataList>
+      <metadata name="numDocs">11</metadata>
+      <metadata name="numSections">231</metadata>
+      <metadata name="iconCollection">demo.gif</metadata>
+      <metadata name="colName">mg demo</metadata>
+      <metadata name="description">A demo collection using MG and GDBM. Currently has no data. </metadata>
+    </metadataList>
+    <servicesImplList>
+      <servicesImpl name="MGGDBMService"/>
+      <servicesImpl name="PhindService"/>
+    </servicesImplList>
+</buildConfig>
Index: trunk/gsdl3/sites/localsite/collect/demo/index/buildcfg.xml
===================================================================
--- trunk/gsdl3/sites/localsite/collect/demo/index/buildcfg.xml	(revision 3479)
+++ 	(revision )
@@ -1,17 +1,0 @@
-<buildConfiguration>
-<metadataList>
-<metadata name="numDocs">11</metadata>
-<metadata name="numSections">231</metadata>
-<metadata name="iconCollection">demo.gif</metadata>
-<metadata name="colName">mg demo</metadata>
-</metadataList>
-<serviceModuleList>
-<serviceModule name="MGGDBMService" type="query">
-<indexList>
-<index name="dtx"/>
-<index name="stt"/>
-</indexList>
-</serviceModule>
-<serviceModule name="PhindService" type="query"/>
-</serviceModuleList>
-</buildConfiguration>
Index: trunk/gsdl3/sites/localsite/collect/demo/index/tmp
===================================================================
--- trunk/gsdl3/sites/localsite/collect/demo/index/tmp	(revision 3479)
+++ 	(revision )
@@ -1,1 +1,0 @@
-<metadata name="metadata"><element name="dc:Title"/><element name="dc:Subject"/></metadata>
Index: trunk/gsdl3/sites/localsite/collect/mgppdemo/index/buildConfig.xml
===================================================================
--- trunk/gsdl3/sites/localsite/collect/mgppdemo/index/buildConfig.xml	(revision 3480)
+++ trunk/gsdl3/sites/localsite/collect/mgppdemo/index/buildConfig.xml	(revision 3480)
@@ -0,0 +1,39 @@
+<buildConfig>
+<metadataList>
+<metadata name="numDocs">11</metadata>
+<metadata name="iconCollection">mgppdemo.gif</metadata>
+<metadata name="colName">mgpp demo</metadata>
+<metadata name="defaultIndex">tt</metadata>
+</metadataList>
+<servicesImplList>
+<servicesImpl name="MGPPGDBMServices">
+<defaultIndex name="tt"/>
+<defaultLevel name="Section"/>
+<levelList>
+<level name="Document"/>
+<level name="Section"/>
+</levelList>
+<indexList>
+<index name="tt">
+<fieldList>
+<field name="TX"/><field name="SU"/><field name="TI"/>
+</fieldList>
+</index>
+<index name="t0"/>
+</indexList>
+<metadataList>
+<element name="Title"/><element name="Subject"/><element name="Organization"/>
+<element name="URL"/>
+</metadataList>
+</servicesImpl>
+<servicesImpl name="PhindServices"/>
+<servicesImpl name="GSDL2ClassifierServices">
+<classifierList>
+<classifier name="CL1"><metadataList><metadata name="Title">Subject</metadata></metadataList></classifier>
+<classifier name="CL2" ><metadataList><metadata name="Title">Title</metadata></metadataList></classifier>
+<classifier name="CL4"><metadataList><metadata name="Title">Organization</metadata></metadataList></classifier>
+<classifier name="CL5" ><metadataList><metadata name="Title">Keyword</metadata></metadataList></classifier>
+</classifierList>
+</servicesImpl>
+</servicesImplList>
+</buildConfig>
Index: trunk/gsdl3/sites/localsite/collect/mgppdemo/index/buildcfg.xml
===================================================================
--- trunk/gsdl3/sites/localsite/collect/mgppdemo/index/buildcfg.xml	(revision 3479)
+++ 	(revision )
@@ -1,39 +1,0 @@
-<buildConfiguration>
-<metadataList>
-<metadata name="numDocs">11</metadata>
-<metadata name="iconCollection">mgppdemo.gif</metadata>
-<metadata name="colName">mgpp demo</metadata>
-<metadata name="defaultIndex">tt</metadata>
-</metadataList>
-<serviceModuleList>
-<serviceModule name="MGPPGDBMService">
-<defaultIndex name="tt"/>
-<defaultLevel name="Section"/>
-<levelList>
-<level name="Document"/>
-<level name="Section"/>
-</levelList>
-<indexList>
-<index name="tt">
-<fieldList>
-<field name="TX"/><field name="SU"/><field name="TI"/>
-</fieldList>
-</index>
-<index name="t0"/>
-</indexList>
-<metadataList>
-<element name="Title"/><element name="Subject"/><element name="Organization"/>
-<element name="URL"/>
-</metadataList>
-</serviceModule>
-<serviceModule name="PhindService"/>
-<serviceModule name="GSDL2ClassifierService">
-<classifierList>
-<classifier name="CL1"><metadataList><metadata name="Title">Subject</metadata></metadataList></classifier>
-<classifier name="CL2" ><metadataList><metadata name="Title">Title</metadata></metadataList></classifier>
-<classifier name="CL4"><metadataList><metadata name="Title">Organization</metadata></metadataList></classifier>
-<classifier name="CL5" ><metadataList><metadata name="Title">Keyword</metadata></metadataList></classifier>
-</classifierList>
-</serviceModule>
-</serviceModuleList>
-</buildConfiguration>
Index: trunk/gsdl3/sites/localsite/sitecfg.xml
===================================================================
--- trunk/gsdl3/sites/localsite/sitecfg.xml	(revision 3479)
+++ 	(revision )
@@ -1,5 +1,0 @@
-<config>
-<localSiteName value="org.greenstone.localsite"/>
-<serviceModuleList>
-</serviceModuleList>
-</config>