Index: trunk/gsdl3/interfaces/default/transform/about.xsl
===================================================================
--- trunk/gsdl3/interfaces/default/transform/about.xsl	(revision 3654)
+++ trunk/gsdl3/interfaces/default/transform/about.xsl	(revision 3655)
@@ -70,16 +70,14 @@
 <tr>
 <xsl:if test="contains($serviceName, 'Query')">
-<xsl:variable name="orig-type"><xsl:value-of select="substring-before($serviceName, 'Query')"/></xsl:variable>
-<xsl:variable name="lower-type" select="java:org.greenstone.gsdl3.util.XSLTUtil.toLower($orig-type)"/>
-<td><a href="{$library}?a=q&amp;sa={$orig-type}&amp;c={$collName}"><xsl:value-of select="$serviceName"/></a></td>
+<xsl:variable name="s-type"><xsl:value-of select="substring-before($serviceName, 'Query')"/></xsl:variable>
+<td><a href="{$library}?a=q&amp;sa={$s-type}&amp;c={$collName}"><xsl:value-of select="$serviceName"/></a></td>
 </xsl:if>
 <xsl:if test="contains($serviceName, 'Browse')">
-<xsl:variable name="orig-type"><xsl:value-of select="substring-before($serviceName, 'Browse')"/></xsl:variable>
-<xsl:variable name="lower-type" select="java:org.greenstone.gsdl3.util.XSLTUtil.toLower($orig-type)"/>
-<td><a href="{$library}?a=b&amp;sa={$orig-type}&amp;c={$collName}"><xsl:value-of select="$serviceName"/></a></td>
+<xsl:variable name="s-type"><xsl:value-of select="substring-before($serviceName, 'Browse')"/></xsl:variable>
+<td><a href="{$library}?a=b&amp;sa={$s-type}&amp;c={$collName}"><xsl:value-of select="$serviceName"/></a></td>
 </xsl:if>
 <xsl:if test="contains($serviceName, 'Applet')">
-<xsl:variable name="orig-type"><xsl:value-of select="substring-before($serviceName, 'Applet')"/></xsl:variable>
-<td><a href="{$library}?a=a&amp;sa=d&amp;sn={$orig-type}&amp;c={$collName}"><xsl:value-of select="$serviceName"/></a></td>
+<xsl:variable name="s-type"><xsl:value-of select="substring-before($serviceName, 'Applet')"/></xsl:variable>
+<td><a href="{$library}?a=a&amp;sa=d&amp;s={$s-type}&amp;c={$collName}"><xsl:value-of select="$serviceName"/></a></td>
 </xsl:if>
 </tr>
@@ -96,5 +94,5 @@
 <table>
 <xsl:for-each select="service">
-<tr><td><a href="{$library}?a={$collName}&amp;sa={@name}"><xsl:value-of select="@name"/></a></td></tr>
+<tr><td><a href="{$library}?a=pr&amp;sa=d&amp;c={$collName}&amp;s={@name}"><xsl:value-of select="@name"/></a></td></tr>
 </xsl:for-each>
 </table>
Index: trunk/gsdl3/interfaces/default/transform/applet.xsl
===================================================================
--- trunk/gsdl3/interfaces/default/transform/applet.xsl	(revision 3654)
+++ trunk/gsdl3/interfaces/default/transform/applet.xsl	(revision 3655)
@@ -9,5 +9,5 @@
 <xsl:template match="page">
 
-<xsl:variable name="collName"><xsl:value-of select="request/paramList/param[@name='collection']/@value"/></xsl:variable>
+<xsl:variable name="collName"><xsl:value-of select="request/paramList/param[@name='c']/@value"/></xsl:variable>
 <html>
 <xsl:call-template name="greenstoneHead"/>
Index: trunk/gsdl3/interfaces/default/transform/basicquery.xsl
===================================================================
--- trunk/gsdl3/interfaces/default/transform/basicquery.xsl	(revision 3654)
+++ trunk/gsdl3/interfaces/default/transform/basicquery.xsl	(revision 3655)
@@ -10,5 +10,5 @@
 <xsl:template match="page">
 
-<xsl:variable name="collName"><xsl:value-of select="request/paramList/param[@name='collection']/@value"/></xsl:variable>
+<xsl:variable name="collName"><xsl:value-of select="request/paramList/param[@name='c']/@value"/></xsl:variable>
 
 <html>
@@ -33,5 +33,4 @@
 <xsl:template match="service">
 <xsl:param name="collName">coll-name</xsl:param>
-<xsl:variable name="queryString"><xsl:value-of select="../request/paramList/param[@name='query']/@value"/></xsl:variable>
 <xsl:variable name="subaction"><xsl:value-of select="../request/@subaction"/></xsl:variable>
 <xsl:variable name='library' select='ancestor::page/config/library_name'/>
@@ -91,6 +90,6 @@
 <xsl:variable name="library" select="ancestor::page/config/library_name"/>
 <table width="537">
-<xsl:for-each select="content/resourceList/resource">
-<tr><td><a href="{$library}?a=r&amp;c={$collName}&amp;r={@name}">link</a></td><td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td></tr>
+<xsl:for-each select="content/documentList/document">
+<tr><td><a href="{$library}?a=d&amp;c={$collName}&amp;d={@name}">link</a></td><td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td></tr>
 </xsl:for-each>
 </table>
Index: trunk/gsdl3/interfaces/default/transform/classifier.xsl
===================================================================
--- trunk/gsdl3/interfaces/default/transform/classifier.xsl	(revision 3654)
+++ trunk/gsdl3/interfaces/default/transform/classifier.xsl	(revision 3655)
@@ -10,5 +10,5 @@
 
 <xsl:template match="page">
-<xsl:variable name="collName"><xsl:value-of select="request/paramList/param[@name='collection']/@value"/></xsl:variable>
+<xsl:variable name="collName"><xsl:value-of select="request/paramList/param[@name='c']/@value"/></xsl:variable>
 <html>
 <xsl:call-template name="greenstoneHead"/>
@@ -42,5 +42,5 @@
 </xsl:when>
 <xsl:otherwise>
-<td align='center'><a href="{$library}?a=b&amp;sa=classifier&amp;c={$collName}&amp;cl={@name}"><xsl:value-of select="metadataList/metadata[@name='Title']"/></a></td></xsl:otherwise></xsl:choose>
+<td align='center'><a href="{$library}?a=b&amp;sa=Classifier&amp;c={$collName}&amp;cl={@name}"><xsl:value-of select="metadataList/metadata[@name='Title']"/></a></td></xsl:otherwise></xsl:choose>
 </xsl:for-each>
 </tr></table>
@@ -48,10 +48,10 @@
 </xsl:template>
 
-<!-- recursively process all nodes and resources -->
+<!-- recursively process all nodes and documents -->
 
 <xsl:template match="classifier[@type='vertical' and @interleave='true']">
 <xsl:param name="collName">coll-name</xsl:param>
 <xsl:variable name='link' select='@link'/>
-<table width='537'><xsl:for-each select='node|resource'>
+<table width='537'><xsl:for-each select='node|document'>
 <xsl:choose><xsl:when test='name()="node"'><tr valign='top'><xsl:apply-templates select='.' mode='current-node'><xsl:with-param name='link' select='$link'/><xsl:with-param name='collName' select='$collName'/></xsl:apply-templates></tr><tr valign='top'><td></td><xsl:apply-templates select='.' mode='process-all-children'><xsl:with-param name='collName' select='$collName'/><xsl:with-param name='link' select='$link'/></xsl:apply-templates></tr>
 </xsl:when>
@@ -66,5 +66,5 @@
 <xsl:param name="collName">coll-name</xsl:param>
 <xsl:variable name='link' select='@link'/>
-<!-- process the nodes and resources separately-->
+<!-- process the nodes and documents separately-->
 <table width='537'>
 <xsl:for-each select='node'>
@@ -72,5 +72,5 @@
 </table>
 <table width='537'>
-<xsl:for-each select='//resource'>
+<xsl:for-each select='//document'>
 <tr valign='top'><xsl:apply-templates select='.'><xsl:with-param name='collName' select='$collName'/></xsl:apply-templates></tr>
 </xsl:for-each>
@@ -82,5 +82,5 @@
 <xsl:param name="collName">coll-name</xsl:param>
 <xsl:variable name='link' select='@link'/>
-<!-- process the nodes and resources separately-->
+<!-- process the nodes and documents separately-->
 
 <table width='537'><tr valign='top'>
@@ -93,5 +93,5 @@
 </table>
 <table width='537'>
-<xsl:for-each select='//resource'>
+<xsl:for-each select='//document'>
 <tr valign='top'><xsl:apply-templates select='.'><xsl:with-param name='collName' select='$collName'/></xsl:apply-templates></tr>
 </xsl:for-each>
@@ -103,8 +103,8 @@
 <xsl:param name="collName">coll-name</xsl:param>
 <xsl:variable name='link' select='@link'/>
-<!-- process the nodes and resources together -->
+<!-- process the nodes and documents together -->
 
 <table><tr valign='top'>
-<xsl:for-each select='node|resource'>
+<xsl:for-each select='node|document'>
 <xsl:choose><xsl:when test='name()="node"'><xsl:apply-templates select='.' mode='current-node'><xsl:with-param name='link' select='$link'/><xsl:with-param name='collName' select='$collName'/></xsl:apply-templates>
 </xsl:when>
@@ -114,6 +114,6 @@
 </tr>
 <tr valign='top'>
-<xsl:for-each select='node|resource'>
-<xsl:choose><xsl:when test='name()="node" and node|resource'><xsl:if test="$link='icon'"><td></td></xsl:if><xsl:apply-templates select='.' mode='process-all-children'><xsl:with-param name='collName' select='$collName'/><xsl:with-param name='link' select='$link'/></xsl:apply-templates></xsl:when>
+<xsl:for-each select='node|document'>
+<xsl:choose><xsl:when test='name()="node" and node|document'><xsl:if test="$link='icon'"><td></td></xsl:if><xsl:apply-templates select='.' mode='process-all-children'><xsl:with-param name='collName' select='$collName'/><xsl:with-param name='link' select='$link'/></xsl:apply-templates></xsl:when>
 <xsl:otherwise><td></td><xsl:if test="$link='icon'"><td></td></xsl:if>
 </xsl:otherwise>
@@ -124,22 +124,22 @@
 </xsl:template>
 
-<!-- different template for resource, not used at the moment
+<!-- different template for document, not used at the moment
 priority attribute used to decide which template to use -->
 <!--
-<xsl:template match="resource" priority="1">
+<xsl:template match="document" priority="1">
 <xsl:param name="collName">coll-name</xsl:param>
 <xsl:variable name='library' select='ancestor::page/config/library_name'/>
 <xsl:variable name='year' select="metadataList/metadata[@name='Year']"/>
 <xsl:variable name='month' select="metadataList/metadata[@name='Month']"/>
-<td><b><xsl:if test="not($year = preceding-sibling::resource[1]/metadataList/metadata[@name='Year'])"><xsl:value-of select="$year"/></xsl:if></b></td>
-<td><b><xsl:if test="not($year = preceding-sibling::resource[1]/metadataList/metadata[@name='Year'] and $month = preceding-sibling::resource[1]/metadataList/metadata[@name='Month'])"><xsl:value-of select="$month"/></xsl:if></b></td>
+<td><b><xsl:if test="not($year = preceding-sibling::document[1]/metadataList/metadata[@name='Year'])"><xsl:value-of select="$year"/></xsl:if></b></td>
+<td><b><xsl:if test="not($year = preceding-sibling::document[1]/metadataList/metadata[@name='Year'] and $month = preceding-sibling::document[1]/metadataList/metadata[@name='Month'])"><xsl:value-of select="$month"/></xsl:if></b></td>
 <td><a href="{$library}?a=r&amp;c={$collName}&amp;r={@name}"><img src='interfaces/default/images/book.gif' width='18' height='11' border='0'/></a></td><td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
 </xsl:template>
 -->
 
-<xsl:template match="resource">
+<xsl:template match="document">
 <xsl:param name="collName">coll-name</xsl:param>
 <xsl:variable name='library' select='ancestor::page/config/library_name'/>
-<td><a href="{$library}?a=r&amp;c={$collName}&amp;r={@name}"><img src='interfaces/default/images/book.gif' width='18' height='11' border='0'/></a></td><td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
+<td><a href="{$library}?a=d&amp;c={$collName}&amp;d={@name}"><img src='interfaces/default/images/book.gif' width='18' height='11' border='0'/></a></td><td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
 </xsl:template>
 
@@ -152,12 +152,12 @@
 <xsl:variable name="library" select="ancestor::page/config/library_name"/>
 <xsl:choose><xsl:when test="$link='icon'">
-<td><a><xsl:attribute name='href'><xsl:value-of select='$library'/>?a=b&amp;sa=classifier&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@name'/><xsl:if test="node|resource">.pr</xsl:if></xsl:attribute><img src='interfaces/default/images/bshelf.gif' border='0' width='20' height='16' /></a></td><td align='left'><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
+<td><a><xsl:attribute name='href'><xsl:value-of select='$library'/>?a=b&amp;sa=Classifier&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@name'/><xsl:if test="node|document">.pr</xsl:if></xsl:attribute><img src='interfaces/default/images/bshelf.gif' border='0' width='20' height='16' /></a></td><td align='left'><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
 </xsl:when><xsl:otherwise>
-<td><a><xsl:attribute name='href'><xsl:value-of select='$library'/>?a=b&amp;sa=classifier&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@name'/><xsl:if test="node|resource">.pr</xsl:if></xsl:attribute><xsl:value-of select="metadataList/metadata[@name='Title']"/></a></td>
+<td><a><xsl:attribute name='href'><xsl:value-of select='$library'/>?a=b&amp;sa=Classifier&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@name'/><xsl:if test="node|document">.pr</xsl:if></xsl:attribute><xsl:value-of select="metadataList/metadata[@name='Title']"/></a></td>
 </xsl:otherwise></xsl:choose>
 </xsl:template>
 
 <!-- processing for the recursive bit -->
-<!-- if interleave=true, process all child nodes and resources, else just do nodes -->
+<!-- if interleave=true, process all child nodes and documents, else just do nodes -->
 
 
@@ -167,5 +167,5 @@
 <td><p/>
 <xsl:choose><xsl:when test='@type="vertical"'>
-<table><xsl:for-each select='node|resource'>
+<table><xsl:for-each select='node|document'>
 <xsl:choose><xsl:when test='name()="node"'><tr valign='top'><xsl:apply-templates select='.' mode='current-node'><xsl:with-param name='link' select='$link'/><xsl:with-param name='collName' select='$collName'/></xsl:apply-templates></tr><tr valign='top'><td></td><xsl:apply-templates select='.' mode='process-all-children'><xsl:with-param name='collName' select='$collName'/><xsl:with-param name='link' select='$link'/></xsl:apply-templates></tr>
 </xsl:when>
@@ -175,5 +175,5 @@
 </xsl:when>
 <xsl:otherwise>
-<table><tr valign='top'><xsl:for-each select='node|resource'>
+<table><tr valign='top'><xsl:for-each select='node|document'>
 <xsl:choose><xsl:when test='name()="node"'><xsl:apply-templates select='.' mode='current-node'><xsl:with-param name='link' select='$link'/><xsl:with-param name='collName' select='$collName'/></xsl:apply-templates><xsl:apply-templates select='.' mode='process-all-children'><xsl:with-param name='collName' select='$collName'/><xsl:with-param name='link' select='$link'/></xsl:apply-templates>
 </xsl:when>
@@ -203,2 +203,6 @@
 
 </xsl:stylesheet>
+
+
+
+
Index: trunk/gsdl3/interfaces/default/transform/home.xsl
===================================================================
--- trunk/gsdl3/interfaces/default/transform/home.xsl	(revision 3654)
+++ trunk/gsdl3/interfaces/default/transform/home.xsl	(revision 3655)
@@ -49,8 +49,9 @@
 <xsl:template match="serviceClusterList">
 <xsl:for-each select="serviceCluster"> 
-<p/><a><xsl:attribute name='href'><xsl:value-of select="ancestor::page/config/library_name"/>?a=p&amp;sa=about&amp;sc=<xsl:value-of select='@name'/></xsl:attribute><xsl:value-of select='@name'/></a>
+<p/><a><xsl:attribute name='href'><xsl:value-of select="ancestor::page/config/library_name"/>?a=p&amp;sa=about&amp;c=<xsl:value-of select='@name'/></xsl:attribute><xsl:value-of select='@name'/></a>
 </xsl:for-each>
 <xsl:call-template name="greenBar"/>
 </xsl:template>
+
 </xsl:stylesheet>  
 
Index: trunk/gsdl3/interfaces/default/transform/service-params.xsl
===================================================================
--- trunk/gsdl3/interfaces/default/transform/service-params.xsl	(revision 3654)
+++ trunk/gsdl3/interfaces/default/transform/service-params.xsl	(revision 3655)
@@ -103,4 +103,4 @@
   </xsl:template>
 
-
+  
 </xsl:stylesheet>  
Index: trunk/gsdl3/interfaces/default/transform/style.xsl
===================================================================
--- trunk/gsdl3/interfaces/default/transform/style.xsl	(revision 3654)
+++ trunk/gsdl3/interfaces/default/transform/style.xsl	(revision 3655)
@@ -74,5 +74,5 @@
 <xsl:variable name="library" select="ancestor::page/config/library_name"/>
 <table width="537">
-<tr><td align="left"><a href="{$library}?a=p&amp;sa=about&amp;sc={$clusterName}"><xsl:value-of select="$clusterName"/></a></td><td align="right"><a href="{$library}?a=p&amp;sa=home"><xsl:call-template name="text"><xsl:with-param name="key">home</xsl:with-param></xsl:call-template></a></td></tr></table>
+<tr><td align="left"><a href="{$library}?a=p&amp;sa=about&amp;c={$clusterName}"><xsl:value-of select="$clusterName"/></a></td><td align="right"><a href="{$library}?a=p&amp;sa=home"><xsl:call-template name="text"><xsl:with-param name="key">home</xsl:with-param></xsl:call-template></a></td></tr></table>
 
 <xsl:call-template name="greenBar"/>